Click or drag to resize

SubDCreateFromSweep Method (NurbsCurve, IEnumerableNurbsCurve, Boolean, Boolean, Boolean, Vector3d)

Fits a SubD through a series of profile curves that define the SubD cross-sections and one curve that defines a SubD edge.

Namespace:  Rhino.Geometry
Assembly:  RhinoCommon (in RhinoCommon.dll)
Since: 7.0
Syntax
public static SubD CreateFromSweep(
	NurbsCurve rail1,
	IEnumerable<NurbsCurve> shapes,
	bool closed,
	bool addCorners,
	bool roadlikeFrame,
	Vector3d roadlikeNormal
)

Parameters

rail1
Type: Rhino.GeometryNurbsCurve
A SubD-friendly NURBS curve to sweep along.
shapes
Type: System.Collections.GenericIEnumerableNurbsCurve
An enumeration of SubD-friendly NURBS curves to sweep through.
closed
Type: SystemBoolean
Creates a SubD that is closed in the rail curve direction.
addCorners
Type: SystemBoolean
With open curves, adds creased vertices to the SubD at both ends of the first and last curves.
roadlikeFrame
Type: SystemBoolean
Determines how sweep frame rotations are calculated. If false (Freeform), frame are propogated based on a refrence direction taken from the rail curve curvature direction. If true (Roadlike), frame rotations are calculated based on a vector supplied in "roadlikeNormal" and the world coordinate system.
roadlikeNormal
Type: Rhino.GeometryVector3d
If roadlikeFrame = true, provide 3D vector used to calculate the frame rotations for sweep shapes. If roadlikeFrame = false, then pass Unset.

Return Value

Type: SubD
A new SubD if successful, or null on failure.
Remarks
Shape curves must be in the proper order and orientation. Shape curves must have the same point counts and rail curves must have the same point counts. Shape curves will relocated to the nearest pair of Greville points on the rails. Shape curves will be made at each pair of rail edit points where there isn't an input shape.
See Also